src/apps/ecidadania/debate/urls.py
# -*- coding: utf-8 -*-
#
# Copyright (c) 2013 Clione Software
# Copyright (c) 2010-2013 Cidadania S. Coop. Galega
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""
This file contains all the URLs that e_cidadania will inherit when the user
access to '/spaces/'.
"""
from django.conf.urls import *
from django.contrib.auth.decorators import permission_required
from apps.ecidadania.debate.views import ListDebates, ViewDebate, DeleteDebate, edit_debate
from apps.ecidadania.debate.url_names import *

urlpatterns = patterns('apps.ecidadania.debate.views',

    url(r'^$', ListDebates.as_view(), name=DEBATE_LIST),

    url(r'^(?P<debate_id>\d+)/', ViewDebate.as_view(), name=DEBATE_VIEW),

    url(r'^add/', 'add_new_debate', name=DEBATE_ADD),

    url(r'^update_position/', 'update_position', name=NOTE_UPDATE_POSITION),

    url(r'^update_note/', 'update_note', name=NOTE_UPDATE),

    url(r'^create_note/', 'create_note', name=NOTE_ADD),

    url(r'^delete_note/', 'delete_note', name=NOTE_DELETE),

    # Editing debates is not allowed at this time
    url(r'^edit/(?P<debate_id>\d+)/', 'edit_debate', name=DEBATE_EDIT),

    url(r'^delete/(?P<debate_id>\d+)', DeleteDebate.as_view(), name=DEBATE_DELETE),

)

src/core/prismriver/dashboard/urls.py
from django.conf.urls.defaults import *

urlpatterns = patterns('', url(r'^$', 'prismriver.dashboard.views.dashboard'))

src/e_cidadania/urls.py
# -*- coding: utf-8 -*-
#
# Copyright (c) 2013 Clione Software
# Copyright (c) 2010-2013 Cidadania S. Coop. Galega
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""
Main URLs for the e-cidadania platform.
"""

from django.conf.urls import *
from django.conf import settings
from django.contrib import admin
from django.contrib.staticfiles.urls import staticfiles_urlpatterns

admin.autodiscover()

# We put here the dictionary with all the packages for translatin JavaScript code
# Please refer to https://docs.djangoproject.com/en/dev/topics/i18n/internationalization/#specifying-translation-strings-in-javascript-code
js_info_dict = {
    'packages': ('apps.ecidadania.debate',),
}

urlpatterns = patterns('',
    # i18n switcher
    (r'^i18n/', include('django.conf.urls.i18n')),
)

urlpatterns += patterns('',

    # Django administration
    (r'^admin/', include(admin.site.urls)),

    # Index
    url(r'^$', 'core.views.index.index_view', name='site-index'),

    # User accounts
    url(r'^accounts/', include('apps.thirdparty.userprofile.urls')),

    # REST API
    url(r'^api/', include('apps.ecidadania.api.urls')),

    # Spaces
    url(r'^spaces/', include('core.spaces.urls')),

    # Invitations
    url(r'^invite/', 'core.views.invite.invite', name='invite'),

    # Explore
    url(r'^explore/$', 'core.views.explore.explore', name='explore'),

    # This urls is for the django comments system
    url(r'^comments/', include('django.contrib.comments.urls')),

    (r'^jsi18n/$', 'django.views.i18n.javascript_catalog', js_info_dict),

    # For smart_selects app
    url(r'^chaining/', include('apps.thirdparty.smart_selects.urls')),

    # This url is for the access to static pages. I hope this doesn't collide
    # with the index view
    url(r'^(?P<slug>[\w\-]+)/', include('apps.ecidadania.staticpages.urls')),

)

if settings.DEBUG:
    # Serve static files
    urlpatterns += staticfiles_urlpatterns()
    # Serve uploaded files
    urlpatterns += patterns('',
        url(r'^uploads/(?P<path>.*)$', 'django.views.static.serve',
            {'document_root': settings.MEDIA_ROOT}),
    )

src/apps/ecidadania/debate/models.py
# -*- coding: utf-8 -*-
#
# Copyright (c) 2013 Clione Software
# Copyright (c) 2010-2013 Cidadania S. Coop. Galega
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""
This file contains all the data models for the debate module.
"""
import datetime

from django.db import models
from django.contrib.auth.models import User
from django.utils.translation import ugettext_lazy as _
from django.core.exceptions import ValidationError

from apps.thirdparty.tagging.fields import TagField
from apps.thirdparty.tagging.models import Tag
from core.spaces.models import Space


class Debate(models.Model):

    """
    Debate object. In every space there can be unlimited debates, each one of
    them holds all the related notes. Debates are filtered by space. Start/End
    dates are for letting users use the debate or not.

    .. versionadded:: 0.1b
    """
    title = models.CharField(_('Title'), max_length=200, unique=True)
    description = models.TextField(_('Description'), blank=True, null=True)
    theme = models.CharField(_('Theme'), blank=True, null=True, max_length=100)

    space = models.ForeignKey(Space, blank=True, null=True)
    date = models.DateTimeField(_('Date created'), auto_now_add=True)
    date_mod = models.DateTimeField(_('Last update'), auto_now=True)
    author = models.ForeignKey(User, blank=True, null=True)
    start_date = models.DateField(_('Start date'))
    end_date = models.DateField(_('End date'))
    private = models.BooleanField(_('Private'), help_text=_('Set the debate as private so only the accepted users can participate in it.'))

    class Meta:
        permissions = (
            ('view_debate', 'Can view the debate'),
            ('admin_debate', 'Can administrate the debate'),
            ('mod_debate', 'Can moderate the debate'),
        )

    def __unicode__(self):
        return self.title

    def is_active(self):
        if datetime.date.today() >= self.end_date or datetime.date.today() <= self.start_date:
            return False
        else:
            return True

    @models.permalink
    def get_absolute_url(self):
        return ('view-debate', (), {
            'space_url': self.space.url,
            'debate_id': str(self.id)})

    def clean(self):
        if self.start_date > self.end_date:
            raise ValidationError('The start date can not be after the end date.')


class Column(models.Model):
    """
    Debate column object. The debate table is done mixing columns and rows. The column
    object is linked to the debate, but with no preferable order.

    .. versionadded:: 0.1b
    """
    criteria = models.CharField(_('Criteria'), max_length=100, blank=True, null=True)
    debate = models.ForeignKey(Debate, blank=True, null=True)

    def __unicode__(self):
        return self.criteria


class Row(models.Model):
    """
    Row object for the debate system.  The row object works exactly like the
    column. It's associated to the debate in no preferred order.

    .. versionadded:: 0.1b
    """
    criteria = models.CharField(_('Criteria'), max_length=100, blank=True, null=True)
    debate = models.ForeignKey(Debate, blank=True, null=True)

    def __unicode__(self):
        return self.criteria


class Note(models.Model):

    """
    The most important object in every debate, the message. It has a coordinates
    value to determine the position of the note in its debate.

    .. versionadded:: 0.1b
    """
    column = models.ForeignKey(Column, null=True, blank=True)
    row = models.ForeignKey(Row, null=True, blank=True)
    debate = models.ForeignKey(Debate, null=True, blank=True)
    title = models.CharField(_('Title'), max_length=60, blank=True, null=True)
    message = models.TextField(_('Message'), max_length=100, null=True, blank=True)

    date = models.DateTimeField(_('Date created'), auto_now_add=True)
    author = models.ForeignKey(User, null=True, blank=True, related_name="note_author")
    last_mod_author = models.ForeignKey(User, null=True, blank=True, related_name="update_author")
    last_mod = models.DateTimeField(_('Last modification time'), auto_now=True)

    def __unicode__(self):
        return self.message

    class Meta:
        permissions = (
            ('move', 'Can move note'),
        )

src/apps/ecidadania/debate/forms.py
# -*- coding: utf-8 -*-
#
# Copyright (c) 2013 Clione Software
# Copyright (c) 2010-2013 Cidadania S. Coop. Galega
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""
This file contains all the forms for the debate modules.
"""

from django.forms import ModelForm, Textarea, TextInput
from django.forms.models import modelformset_factory

from apps.ecidadania.debate.models import Debate, Note, Row, Column


class DebateForm(ModelForm):

    """
    Returns an empty form for creating a new Debate.

    :rtype: HTML Form

    .. versionadded:: 0.1b
    """
    class Meta:
        model = Debate
        widgets = {
            'title': TextInput(attrs={'class': 'medium'}),
        }

RowForm = modelformset_factory(Row, exclude=('debate'))
ColumnForm = modelformset_factory(Column, exclude=('debate'))


class NoteForm(ModelForm):

    """
    Returns an HTML Form to create or edit a new 'note' or 'proposal' like it's
    called on the sociologists argot.

    :rtype: HTML Form

    .. versionadded:: 0.1b
    """
    class Meta:
        model = Note


class UpdateNoteForm(ModelForm):

    """
    Returns a more simple version of the NoteForm for the AJAX interaction,
    preventing modification of significative fields non relevant to AJAX.

    :rtype: HTML Form
    .. versionadded:: 0.1b
    """
    class Meta:
        model = Note
        exclude = ('debate', 'author', 'row', 'column', 'date')


class UpdateNotePosition(ModelForm):

    """
    This is a partial form to save only the position updates of the notes in the
    debates. This form excludes all the fields except Column and Row just for
    security, this wau the original data of the note cannot be modified. Moving
    notes does not count as modification, so we also exclude last modification data.

    :rtype: HTML Form
    .. versionadded:: 0.1.5
    """
    class Meta:
        model = Note
        exclude = ('author', 'debate', 'last_mod', 'last_mod_author', 'date',
            'message', 'title')

src/apps/ecidadania/debate/templates/debate/debate_add.html
{% extends "base.html" %}
{% load i18n %}
{% load static from staticfiles %}
{% load wysiwyg %}

{% comment %}
The way to validate in this form if it is an edit or an add request is to
validate the title field. If it's True, it means that it's populated, therefore
we're editing the form. Remember that this tempalte shows the help_text
automatically if found in the data models.
{% endcomment %}

{% block title %}
    {% if form.title.value %}
        {% trans "Edit debate" %} {{ form.title.value }}
    {% else %}
        {% trans "Create new debate" %}
    {% endif %}
{% endblock %}

{% block logo %}
    <a href="{{ get_place.get_absolute_url }}"><img src="{{ MEDIA_URL }}/{{ get_place.logo }}" /></a>
{% endblock %}

{% block banner %}
    <img src="{{ MEDIA_URL }}/{{ get_place.banner }}" />
{% endblock %}

{% block extrajs %}
    <script src="{% static 'js/jquery.formset.js' %}" type="text/javascript"></script>
    <script src="{% static 'js/debate_board.js' %}" type="text/javascript"></script>
    <script type="text/javascript">
        $(function() {
            $('#ajaxform thead tr').formset();
            $('#ajaxform tbody tr').formset();
        })
        $( "#datepicker-start" ).datepicker( $.datepicker.regional[ "{{ LANGUAGE_CODE }}" ] );
        $( "#datepicker-end" ).datepicker( $.datepicker.regional[ "{{ LANGUAGE_CODE }}" ] );
    </script>
{% endblock %}

{% block content %}
    {% if form.title.value %}
        <h3>{% trans "Edit debate" %} {{ form.title.value }}</h3>
    {% else %}
        <h3>{% trans "Create new debate" %} <a data-toggle="modal" id="debate-tutorial" href="#myModal" ><img src="{% static 'assets/icons/question.png' %}" /></a>
</h3>
        <div class="modal hide fade" id="myModal">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal">×</button>
                <h3>{% trans "How to create a debate" %}</h3>
            </div>
            <div class="modal-body">
                <p>{% blocktrans %}To create a debate, you must fill the fields with any criteria necessary for it,
                    in this docuemntation page we have an example of a debate that you can follow to create yours.
                    For the rest of the fields, just follow their respective instructions.{% endblocktrans %}
                </p>
            </div>
            <div class="modal-footer">
                <a href="#" class="btn" data-dismiss="modal">{% trans "Close" %}</a>
            </div>
        </div>
        <br>
    {% endif %}

<div class="row">

    <span class="btn btn-small btn-danger" id="del-column-btn" onclick="removeTableColumn()">{% trans "Remove column" %}</span>
    <span class="btn btn-small btn-primary" id="new-column-btn" onclick="addTableColumn()">{% trans "Add column" %}</span>

    <span class="btn btn-small btn-danger" onclick="removeTableRow()">{% trans "Remove row" %}</span>
    <span class="btn btn-small btn-primary" onclick="addTableRow()">{% trans "Add row" %}</span>

    <div id="debate-number" class="hidden">{{ debateid }}</div>

    <hr />

    <div id="debate">

        <form class="form-horizontal" id="ajaxform" enctype="" action="" method="post">{% csrf_token %}
            <table id="debate{{ debateid }}" cellspacing="0" cellpadding="0" border="0">
                <thead>
                <tr id="debate{{ debateid }}-headers">
                    {{ colform.management_form }}
                    <th id="corner" class="corner-criteria"></th>
                    {% for col in colform.forms %}
                     {% if form.title.value %}
                        {{ col.id }}
                     {% endif %}
                        <th id="debate-vcriteria{{ debate_id }}" class="criteria-vtitle">
                            {{ col.criteria }}
                        </th>
                    {% endfor %}
                </tr>
                </thead>
                <tbody id="debate-body">
                {{ rowform.management_form }}
                {% for row in rowform.forms %}
                     {% if form.title.value %}
                        {{ row.id }}
                     {% endif %}
                <tr>
                    <td id="debate-hcriteria" class="criteria-htitle">
                        <div id="debate-ttitle">
                            {{ row.criteria }}
                        </div>
                    </td>
                    <td id="sortable-debate{{ debateid }}" class="connectedSortable"></td>
                </tr>
                {% endfor %}
                </tbody>
            </table>
            <!--
                <span class="btn btn-small  btn-primary" onclick="createNote()">{% trans "Add new note" %}</span>
                <span class="btn btn-small  btn-primary" onclick="addForm(this, 'form')">{% trans "Change color" %}</span>
            -->
            <hr />

            <h3>{% trans "Other debate data" %}</h3><br/><br/>

            {% if form.non_field_errors %}
                {% for error in form.non_field_errors %}
                    <span class="help-inline">{{ error|escape }}</span>
                {% endfor %}
            {% endif %}

            <div class="control-group {% if form.private.errors %}error{% endif %}">
                <label class="control-label">{{ form.private.label }}</label>
                <div class="controls">
                    <div class="input-append">
                        {{ form.private }}
                        {% if form.private.help_text %}
                            <span class="add-on"><a href="#" rel="tooltip" title="{{ form.private.help_text }}"><i class="icon-question-sign"></i></a></span>
                        {% endif %}
                    </div>
                    {% if form.private.errors %}
                        <p class="help-block">
                            {% for error in form.private.errors %}
                                {{ error|escape }}
                            {% endfor%}
                        </p>
                    {% endif %}
                </div>
            </div>

            <div class="control-group {% if form.title.errors %}error{% endif %}">
                <label class="control-label">{{ form.title.label }}</label>
                <div class="controls">
                    <div class="input-append">
                        {{ form.title }}
                        {% if form.title.help_text %}
                            <span class="add-on"><a href="#" rel="tooltip" title="{{ form.title.help_text }}"><i class="icon-question-sign"></i></a></span>
                        {% endif %}
                    </div>
                    {% if form.title.errors %}
                        <p class="help-block">
                            {% for error in form.title.errors %}
                                {{ error|escape }}
                            {% endfor%}
                        </p>
                    {% endif %}
                </div>
            </div>

            <div class="control-group {% if form.theme.errors %}error{% endif %}">
                <label class="control-label">{{ form.theme.label }}</label>
                <div class="controls">
                    <div class="input-append">
                        {{ form.theme }}
                        {% if form.theme.help_text %}
                            <span class="add-on"><a href="#" rel="tooltip" title="{{ form.theme.help_text }}"><i class="icon-question-sign"></i></a></span>
                        {% endif %}
                    </div>
                    {% if form.theme.errors %}
                        <p class="help-block">
                            {% for error in form.theme.errors %}
                                {{ error|escape }}
                            {% endfor%}
                        </p>
                    {% endif %}
                </div>
            </div>

            <div class="control-group {% if form.start_date.errors %}error{% endif %}">
                <label class="control-label">{{ form.start_date.label }}</label>
                <div class="controls">
                    <div class="input-append">
                        <input type="text" name="start_date" id="datepicker-start" class="hasDatePicker notranslate">
                        {% if form.start_date.help_text %}
                            <span class="add-on"><a href="#" rel="tooltip" title="{{ form.start_date.help_text }}"><i class="icon-question-sign"></i></a></span>
                        {% endif %}
                    </div>
                    {% if form.start_date.errors %}
                        <p class="help-block">
                            {% for error in form.start_date.errors %}
                                {{ error|escape }}
                            {% endfor%}
                        </p>
                    {% endif %}
                </div>
            </div>

            <div class="control-group {% if form.end_date.errors %}error{% endif %}">
                <label class="control-label">{{ form.end_date.label }}</label>
                <div class="controls">
                    <div class="input-append">
                        <input type="text" name="end_date" id="datepicker-end" class="hasDatePicker notranslate">
                        {% if form.end_date.help_text %}
                            <span class="add-on"><a href="#" rel="tooltip" title="{{ form.end_date.help_text }}"><i class="icon-question-sign"></i></a></span>
                        {% endif %}
                    </div>
                    {% if form.end_date.errors %}
                        <p class="help-block">
                            {% for error in form.end_date.errors %}
                                {{ error|escape }}
                            {% endfor%}
                        </p>
                    {% endif %}
                </div>
            </div>

            <div class="control-group {% if form.description.errors %}error{% endif %}">
                <label class="control-label">{{ form.description.label }}</label>
                <div class="controls">
                    <div class="input-prepend">
                        {{ form.description }}
                        {% wysiwyg_editor "id_description" %}
                        {% if form.description.help_text %}
                            <span class="add-on"><a href="#" rel="tooltip" title="{{ form.description.help_text }}"><i class="icon-question-sign"></i></a></span>
                        {% endif %}
                    </div>
                    {% if form.description.errors %}
                        {% for error in form.description.errors %}
                            {{ error|escape }}
                        {% endfor %}
                    {% endif %}
                </div>
            </div>

            {{ form.columns.as_hidden }}

            <hr />
            <a href="{{ get_place.get_absolute_url }}" class="btn btn-danger btn-small">{% trans "Cancel" %}</a>
            <input class="btn btn-primary btn-small" type="submit" value="{% trans 'Save' %}" />
        </form>
    </div>
</div>
</br>
{% endblock %}

src/apps/ecidadania/debate/templates/debate/debate_confirm_delete.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}{% trans "Delete debate" %}{% endblock %}
{% block logo %}
    {% if get_place %}
        <a href="{{ get_place.get_absolute_url }}"><img src="{{ MEDIA_URL }}/{{ get_place.logo }}" /></a>
    {% endif %}
{% endblock %}
  
{% block banner %}
    {% if get_place %}
        <img src="{{ MEDIA_URL }}/{{ get_place.banner }}" />
    {% endif %}
{% endblock %}

{% block content %}

    <div class="row">
        <div class="span12">
            <h4>{% trans "Delete debate" %}</h4>
            <form action="" method="post">{% csrf_token %}
                <p>{% trans "Are you sure you want to delete this debate? This action cannot be undone." %}</p>

                <hr />
                <a href="{{ get_place.get_absolute_url }}" class="btn btn-small">&laquo; {% trans "Go back" %}</a>
                <input class="btn btn-small btn-danger" type="submit" value="{% trans 'Delete' %}" />
            </form>
        </div>
    </div>

{% endblock %}

src/apps/ecidadania/debate/templates/debate/debate_list.html
{% extends "base.html" %}
{% load i18n %}
{% load static from staticfiles %}

{% block title %}{% trans "Debates in " %}{{ get_place.name }}{% endblock %}

{% block content %}

    <div class="row">
        <div class="span12">
            <h3>{% trans "Debates in" %} {{ get_place.name }}</h3>

            {% for debate in object_list %}
                <div id="spaceitem">
                    <h6 class="spacetitle"><a href="{{ debate.get_absolute_url }}">{{ debate.title }}</a></h6>
		    <div id="tools">
			{% if perms.debate.change_debate %}
			<a href="{% url 'edit-debate' get_place.url debate.id %}"><img src="{% static 'assets/icons/edit16.png' %}" alt="{% trans 'Edit' %}" title="{% trans 'Edit' %}"/></a>
			{% endif %}
			{% if perms.debate.delete_debate %}
			<a href="{% url 'delete-debate' get_place.url debate.id %}"><img src="{% static 'assets/icons/delete16.png' %}" alt="{% trans 'Delete' %}" title="{% trans 'Delete' %}"/></a>
			{% endif %}
		    </div>

                    <p class="spacedesc">{{ debate.description|removetags:"p"|safe }}</p>
                </div>
            {% empty %}
                <p>{% trans "There are no debates." %}</p>
            {% endfor %}

            <hr />
            <a href="{% url 'space-index' get_place.url %}" class="btn small">&laquo; {% trans "Go back" %}</a>

            {% if is_paginated %}
            <div class="pagination">
                <span class="page-links">
                    {% if page_obj.has_previous %}
                        <a href="{% url 'list-debates' get_place.url %}?page={{ page_obj.previous_page_number }}">&laquo; {% trans "previous" %} | </a>
                    {% endif %}
                    <span class="page-current">
                        {{ page_obj.number }} {% trans "of" %} {{ page_obj.paginator.num_pages }}
                    </span>
                    {% if page_obj.has_next %}
                        <a href="{% url 'list-debates' get_place.url %}?page={{ page_obj.next_page_number }}"> | {% trans "next" %} &raquo;</a>
                    {% endif %}
                </span>
            </div>
            {% endif %}
        </div>
    </div>

{% endblock %}

src/apps/ecidadania/debate/templates/debate/debate_outdated.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}{% trans "Can't view this debate" %}{% endblock %}
{% block logo %}<a href="{{ get_place.get_absolute_url }}"><img src="{{ MEDIA_URL }}/{{ get_place.logo }}" /></a>{% endblock %}
{% block banner %}<img src="{{ MEDIA_URL }}/{{ get_place.banner }}" />{% endblock %}

{% block space %}
    <a class="brand" href="{{ get_place.get_absolute_url }}">{{ get_place.name }}</a>
{% endblock %}

{% block content %}

    <div class="row">
        <div class="span12">
            <h4>{% trans "Can't view this debate" %}: {{ debate.title }}</h4>
            <p>{% trans "It seems that the debate you're trying to access has <strong>not started</strong>." %}</p>
            <div class="row">
                <div class="span6">
                    <h6>{% trans "Started on:" %}</h6> {{ debate.start_date }}
                </div>
                <div class="span6">
                    <h6>{% trans "Finished on:" %}</h6> {{ debate.end_date }}
                </div>
            </div>
        </div>
    </div>

{% endblock %}